#!/usr/bin/ruby
require 'serialport.so'
require 'presencebot.rb'
require 'serialpresencebot.rb'

#Registro previo
#http://settings.messenger.live.com/applications/websignup.aspx?returnurl=http://phybo.com/viewStatus.html&privacyurl=http://phybo.com/Privacy.htm&wa=wsignin1.0

#msn_id = '9e32122b2391bc22'


class PresenceBotLauncher
  HANDLED_SIGNALS = ["INT","TERM"]
  KEYS_ENABLED = true
  
  def stop_presence_bot
    puts "Stopping..."
    @presence_bot.stop_now
  end
  
  def init_params
    if $*.length > 1
      puts 'Usage: ruby test.rb msn_id'
      exit
    elsif $*.length == 1
      @msn_id = $*[0]
      
    elsif $*.length == 0
      puts 'After registry, launch using msn_id'
      register
      exit
      
    end
    
  end
      
  def init_signal_handling
    stop_block = lambda do
      stop_presence_bot
    end
    
    HANDLED_SIGNALS.each { |signal| Signal.trap(signal, stop_block) }
    
  end
  
  def register
    require 'rubygems'
    require 'launchy'
    
    #url = "http://settings.messenger.live.com/applications/websignup.aspx?returnurl=http://phybo.com/viewStatus.html&privacyurl=http://phybo.com/Privacy.htm&wa=wsignin1.0"
    
    url = "http://phybo.com/register.html"
    
    Launchy.open(url)
    
  end
  
  def run
    
    init_params
    
    @presence_bot = SerialPresenceBot.new(@msn_id)
    
    init_signal_handling
    
    puts "Started: #{@msn_id}"
    
    @presence_bot.start_now
    
    while (@presence_bot.running?)
      sleep 0.1
      
      if (KEYS_ENABLED) 
        char = $stdin.gets.chomp
        if (char.eql?("0"))
            @presence_bot.offline_event;
            
        elsif (char.eql?("1"))
            @presence_bot.online_event;
            
        end
        
      end
      
    end
    
    puts 'Stopped'
    
  end
  
end

PresenceBotLauncher.new.run

