require 'presencebot.rb'


class SerialPresenceBot < PresenceBot
  GO_UP_SYMBOL = '2'
  GO_DOWN_SYMBOL = '4'
  SERIAL_SLOW_UP_SYMBOL = '8'
  SERIAL_SLOW_DOWN_SYMBOL = '9'
  EYES_ON_SYMBOL = 'e'
  EYES_OFF_SYMBOL = 's'
  SYMBOL_PAUSE = 0.1
  MOVEMENT_PAUSE = 0.5
  
  def initialize(msn_id, sleep_period=1)
    super
    
    #params for serial port
    port_str = "/dev/ttyUSB0"  #may be different for you
    baud_rate = 115200
    data_bits = 8
    stop_bits = 1
    parity = SerialPort::NONE
    
    @sp = SerialPort.new(port_str, baud_rate, data_bits, stop_bits, parity)
    
    @sp.putc(SERIAL_SLOW_DOWN_SYMBOL)
    @sp.putc(EYES_OFF_SYMBOL)
    sleep(SYMBOL_PAUSE)
    
  end
  
  def online_event
    super
    #puts "send #{GO_UP_SYMBOL}"
    @sp.putc(SERIAL_SLOW_UP_SYMBOL)
    @sp.putc(EYES_ON_SYMBOL)
    sleep(SYMBOL_PAUSE)
    sleep(MOVEMENT_PAUSE)
    @sp.putc(GO_DOWN_SYMBOL)
    sleep(MOVEMENT_PAUSE)
    @sp.putc(EYES_OFF_SYMBOL)
    sleep(SYMBOL_PAUSE)
    @sp.putc(EYES_ON_SYMBOL)
    sleep(SYMBOL_PAUSE)
    
  end
  
  def offline_event
    super
    #puts "send #{GO_DOWN_SYMBOL}"
    @sp.putc(SERIAL_SLOW_DOWN_SYMBOL)
    @sp.putc(EYES_OFF_SYMBOL)
    sleep(SYMBOL_PAUSE)
    
  end

  def SerialPresenceBot.finalize(id)
    puts "Object #{id} dying at #{Time.new}"
    @sp.close if @sp
    
  end
  
end